<template>
  <label :class="$style.checkbox">
    <slot></slot>
    <input
      type="checkbox"
      :name="name"
      :disabled="disabled"
      v-model="checkBoxValue"
      @change="onChange"
    />
    <span :class="$style.checkmark"></span>
  </label>
</template>

<script lang="ts">
import Vue from "vue";

export default Vue.extend({
  name: "BaseCheckbox",
  props: {
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    defaultValue: {
      type: Boolean,
      required: false,
      default: false
    },
    name: {
      type: String,
      required: true,
      default: ""
    }
  },
  data: function() {
    return {
      checkBoxValue: this.defaultValue || false
    };
  },
  methods: {
    onChange: function() {
      this.$emit("onChange", this.checkBoxValue);
    }
  }
});
</script>

<style module lang="scss">
.checkbox {
  display: flex;
  position: relative;
  padding-left: 35px;
  margin-bottom: 12px;
  cursor: pointer;
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
}

.checkbox input {
  position: absolute;
  opacity: 0;
  cursor: pointer;
  height: 0;
  width: 0;
}

.checkmark {
  position: absolute;
  top: 0;
  left: 0;
  height: 25px;
  width: 25px;
  background-color: #eee;
}

.checkbox:hover input ~ .checkmark {
  background-color: #ccc;
}

.checkbox input:checked ~ .checkmark {
  background-color: $color--orange;
}

.checkmark:after {
  content: "";
  position: absolute;
  display: none;
}

.checkbox input:checked ~ .checkmark:after {
  display: block;
}

.checkbox .checkmark:after {
  left: 9px;
  top: 1px;
  width: 5px;
  height: 1rem;
  border: solid white;
  border-width: 0 3px 3px 0;
  -webkit-transform: rotate(45deg);
  -ms-transform: rotate(45deg);
  transform: rotate(45deg);
}
</style>
